diff --git a/src/mongo/db/matcher/expression_expr.h b/src/mongo/db/matcher/expression_expr.h
index bd50d2e94f..060c57d5e1 100644
--- a/src/mongo/db/matcher/expression_expr.h
+++ b/src/mongo/db/matcher/expression_expr.h
@@ -49,11 +49,15 @@ public:
     ExprMatchExpression(boost::intrusive_ptr<Expression> expr,
                         const boost::intrusive_ptr<ExpressionContext>& expCtx);
 
-    bool matchesSingleElement(const BSONElement& e, MatchDetails* details = nullptr) const final {
+    bool matchesSingleElement(const BSONElement& e,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         MONGO_UNREACHABLE;
     }
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const final;
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* explain = nullptr) const final;
 
     std::unique_ptr<MatchExpression> shallowClone() const final;
 
diff --git a/src/mongo/db/matcher/expression_geo.cpp b/src/mongo/db/matcher/expression_geo.cpp
index 5cab016b9b..837f4febe9 100644
--- a/src/mongo/db/matcher/expression_geo.cpp
+++ b/src/mongo/db/matcher/expression_geo.cpp
@@ -345,7 +345,9 @@ GeoMatchExpression::GeoMatchExpression(StringData path,
                                        const BSONObj& rawObj)
     : LeafMatchExpression(GEO, path), _rawObj(rawObj), _query(query), _canSkipValidation(false) {}
 
-bool GeoMatchExpression::matchesSingleElement(const BSONElement& e, MatchDetails* details) const {
+bool GeoMatchExpression::matchesSingleElement(const BSONElement& e,
+                                              ArrayPositionalMatch* details,
+                                              std::deque<std::string>* explain) const {
     if (!e.isABSONObj())
         return false;
 
@@ -430,7 +432,8 @@ GeoNearMatchExpression::GeoNearMatchExpression(StringData path,
     : LeafMatchExpression(GEO_NEAR, path), _rawObj(rawObj), _query(query) {}
 
 bool GeoNearMatchExpression::matchesSingleElement(const BSONElement& e,
-                                                  MatchDetails* details) const {
+                                                  ArrayPositionalMatch* details,
+                                                  std::deque<std::string>* explain) const {
     return true;
 }
 
diff --git a/src/mongo/db/matcher/expression_geo.h b/src/mongo/db/matcher/expression_geo.h
index 34b015484e..a22ed37bcd 100644
--- a/src/mongo/db/matcher/expression_geo.h
+++ b/src/mongo/db/matcher/expression_geo.h
@@ -85,7 +85,9 @@ public:
 
     virtual ~GeoMatchExpression() {}
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual void debugString(StringBuilder& debug, int level = 0) const;
 
@@ -176,7 +178,9 @@ public:
      * Stub implementation that should never be called, since geoNear execution requires an
      * appropriate geo index.
      */
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual void debugString(StringBuilder& debug, int level = 0) const;
 
diff --git a/src/mongo/db/matcher/expression_internal_expr_eq.cpp b/src/mongo/db/matcher/expression_internal_expr_eq.cpp
index 61306a13fd..61f22bca55 100644
--- a/src/mongo/db/matcher/expression_internal_expr_eq.cpp
+++ b/src/mongo/db/matcher/expression_internal_expr_eq.cpp
@@ -38,7 +38,8 @@ namespace mongo {
 constexpr StringData InternalExprEqMatchExpression::kName;
 
 bool InternalExprEqMatchExpression::matchesSingleElement(const BSONElement& elem,
-                                                         MatchDetails* details) const {
+                                                         ArrayPositionalMatch* details,
+                                                         std::deque<std::string>* explain) const {
     // We use NonLeafArrayBehavior::kMatchSubpath traversal in InternalExprEqMatchExpression. This
     // means matchesSinglElement() will be called when an array is found anywhere along the patch we
     // are matching against. When this occurs, we return 'true' and depend on the corresponding
diff --git a/src/mongo/db/matcher/expression_internal_expr_eq.h b/src/mongo/db/matcher/expression_internal_expr_eq.h
index 3a890eaa7d..458203b1d5 100644
--- a/src/mongo/db/matcher/expression_internal_expr_eq.h
+++ b/src/mongo/db/matcher/expression_internal_expr_eq.h
@@ -65,7 +65,9 @@ public:
         return kName;
     }
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails*) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch*,
+                              std::deque<std::string>* explain) const final;
 
     std::unique_ptr<MatchExpression> shallowClone() const final;
 };
diff --git a/src/mongo/db/matcher/expression_leaf.cpp b/src/mongo/db/matcher/expression_leaf.cpp
index b2c92ed892..5a082a9814 100644
--- a/src/mongo/db/matcher/expression_leaf.cpp
+++ b/src/mongo/db/matcher/expression_leaf.cpp
@@ -113,7 +113,8 @@ ComparisonMatchExpression::ComparisonMatchExpression(MatchType type,
 }
 
 bool ComparisonMatchExpression::matchesSingleElement(const BSONElement& e,
-                                                     MatchDetails* details) const {
+                                                     ArrayPositionalMatch* details,
+                                                     std::deque<std::string>* explain) const {
     if (e.canonicalType() != _rhs.canonicalType()) {
         // We can't call 'compareElements' on elements of different canonical types.  Usually
         // elements with different canonical types should never match any comparison, but there are
@@ -153,40 +154,54 @@ bool ComparisonMatchExpression::matchesSingleElement(const BSONElement& e,
         bool bothNaN = std::isnan(e.numberDouble()) && std::isnan(_rhs.numberDouble());
         switch (matchType()) {
             case LT:
+            case GT:
+                if (explain) {
+                    explain->push_front(str::stream() << e.toString(false) << " is not " << name()
+                                                      << " "
+                                                      << _rhs.toString(false));
+                }
                 return false;
             case LTE:
-                return bothNaN;
             case EQ:
-                return bothNaN;
-            case GT:
-                return false;
             case GTE:
+                if (!bothNaN && explain) {
+                    explain->push_front(str::stream() << e.toString(false) << " is not " << name()
+                                                      << " "
+                                                      << _rhs.toString(false));
+                }
                 return bothNaN;
             default:
-                // This is a comparison match expression, so it must be either
-                // a $lt, $lte, $gt, $gte, or equality expression.
-                fassertFailed(17448);
+                MONGO_UNREACHABLE;
         }
     }
 
     int x = BSONElement::compareElements(
         e, _rhs, BSONElement::ComparisonRules::kConsiderFieldName, _collator);
+    bool res;
     switch (matchType()) {
         case LT:
-            return x < 0;
+            res = x < 0;
+            break;
         case LTE:
-            return x <= 0;
+            res = x <= 0;
+            break;
         case EQ:
-            return x == 0;
+            res = x == 0;
+            break;
         case GT:
-            return x > 0;
+            res = x > 0;
+            break;
         case GTE:
-            return x >= 0;
+            res = x >= 0;
+            break;
         default:
-            // This is a comparison match expression, so it must be either
-            // a $lt, $lte, $gt, $gte, or equality expression.
-            fassertFailed(16828);
+            MONGO_UNREACHABLE;
+    }
+    if (!res && explain) {
+        explain->push_front(str::stream() << e.toString(false) << " is not " << name() << " "
+                                          << _rhs.toString(false));
     }
+    return res;
 }
 
 constexpr StringData EqualityMatchExpression::kName;
@@ -258,7 +273,9 @@ bool RegexMatchExpression::equivalent(const MatchExpression* other) const {
         _flags == realOther->_flags;
 }
 
-bool RegexMatchExpression::matchesSingleElement(const BSONElement& e, MatchDetails* details) const {
+bool RegexMatchExpression::matchesSingleElement(const BSONElement& e,
+                                                ArrayPositionalMatch* details,
+                                                std::deque<std::string>* explain) const {
     switch (e.type()) {
         case String:
         case Symbol: {
@@ -266,11 +283,35 @@ bool RegexMatchExpression::matchesSingleElement(const BSONElement& e, MatchDetai
             // pcrecpp::StringPiece instance using the full length of the string to avoid truncating
             // 'data' early.
             pcrecpp::StringPiece data(e.valuestr(), e.valuestrsize() - 1);
-            return _re->PartialMatch(data);
+            bool res = _re->PartialMatch(data);
+            if (!res && explain) {
+                explain->push_front(
+                    str::stream() << e.valueStringData() << " does not match {regex: " << _regex
+                                  << ", flags: "
+                                  << _flags
+                                  << "}");
+            }
+            return res;
+        }
+        case RegEx: {
+            bool res = (_regex == e.regex() && _flags == e.regexFlags());
+            if (!res && explain) {
+                explain->push_front(str::stream() << "{regex: " << _regex << ", flags: " << _flags
+                                                  << "} is not equal to "
+                                                  << "{regex: "
+                                                  << e.regex()
+                                                  << ", flags: "
+                                                  << e.regexFlags()
+                                                  << "}");
+            }
+            return res;
         }
-        case RegEx:
-            return _regex == e.regex() && _flags == e.regexFlags();
         default:
+            if (explain) {
+                explain->push_front(str::stream() << "regex " << _regex
+                                                  << " won't match element of type "
+                                                  << e.type());
+            }
             return false;
     }
 }
@@ -313,7 +354,9 @@ ModMatchExpression::ModMatchExpression(StringData path, int divisor, int remaind
     uassert(ErrorCodes::BadValue, "divisor cannot be 0", divisor != 0);
 }
 
-bool ModMatchExpression::matchesSingleElement(const BSONElement& e, MatchDetails* details) const {
+bool ModMatchExpression::matchesSingleElement(const BSONElement& e,
+                                              ArrayPositionalMatch* details,
+                                              std::deque<std::string>* explain) const {
     if (!e.isNumber())
         return false;
     return e.numberLong() % _divisor == _remainder;
@@ -349,7 +392,8 @@ bool ModMatchExpression::equivalent(const MatchExpression* other) const {
 ExistsMatchExpression::ExistsMatchExpression(StringData path) : LeafMatchExpression(EXISTS, path) {}
 
 bool ExistsMatchExpression::matchesSingleElement(const BSONElement& e,
-                                                 MatchDetails* details) const {
+                                                 ArrayPositionalMatch* details,
+                                                 std::deque<std::string>* explain) const {
     return !e.eoo();
 }
 
@@ -402,7 +446,9 @@ std::unique_ptr<MatchExpression> InMatchExpression::shallowClone() const {
     return std::move(next);
 }
 
-bool InMatchExpression::matchesSingleElement(const BSONElement& e, MatchDetails* details) const {
+bool InMatchExpression::matchesSingleElement(const BSONElement& e,
+                                             ArrayPositionalMatch* details,
+                                             std::deque<std::string>* explain) const {
     if (_hasNull && e.eoo()) {
         return true;
     }
@@ -691,7 +737,8 @@ bool BitTestMatchExpression::performBitTest(const char* eBinary, uint32_t eBinar
 }
 
 bool BitTestMatchExpression::matchesSingleElement(const BSONElement& e,
-                                                  MatchDetails* details) const {
+                                                  ArrayPositionalMatch* details,
+                                                  std::deque<std::string>* explain) const {
     // Validate 'e' is a number or a BinData.
     if (!e.isNumber() && e.type() != BSONType::BinData) {
         return false;
diff --git a/src/mongo/db/matcher/expression_leaf.h b/src/mongo/db/matcher/expression_leaf.h
index b45b1da16a..db303a32a6 100644
--- a/src/mongo/db/matcher/expression_leaf.h
+++ b/src/mongo/db/matcher/expression_leaf.h
@@ -166,7 +166,9 @@ public:
 
     virtual ~ComparisonMatchExpression() = default;
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 };
 
 class EqualityMatchExpression final : public ComparisonMatchExpression {
@@ -300,7 +302,9 @@ public:
         return std::move(e);
     }
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual void debugString(StringBuilder& debug, int level) const;
 
@@ -344,7 +348,9 @@ public:
         return std::move(m);
     }
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual void debugString(StringBuilder& debug, int level) const;
 
@@ -380,7 +386,9 @@ public:
         return std::move(e);
     }
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual void debugString(StringBuilder& debug, int level) const;
 
@@ -403,7 +411,9 @@ public:
 
     virtual std::unique_ptr<MatchExpression> shallowClone() const;
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual void debugString(StringBuilder& debug, int level) const;
 
@@ -492,7 +502,9 @@ public:
                                     uint32_t bitMaskLen);
     virtual ~BitTestMatchExpression() {}
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual void debugString(StringBuilder& debug, int level) const;
 
diff --git a/src/mongo/db/matcher/expression_leaf_test.cpp b/src/mongo/db/matcher/expression_leaf_test.cpp
index 235e2af641..25df1255f2 100644
--- a/src/mongo/db/matcher/expression_leaf_test.cpp
+++ b/src/mongo/db/matcher/expression_leaf_test.cpp
@@ -213,15 +213,15 @@ TEST(EqOp, MatchesThroughNestedArray) {
 TEST(EqOp, ElemMatchKey) {
     BSONObj operand = BSON("a" << 5);
     EqualityMatchExpression eq("a", operand["a"]);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!eq.matchesBSON(BSON("a" << 4), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(eq.matchesBSON(BSON("a" << 5), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(eq.matchesBSON(BSON("a" << BSON_ARRAY(1 << 2 << 5)), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("2", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("2", *details.arrayPosition());
 }
 
 // SERVER-14886: when an array is being traversed explictly at the same time that a nested array
@@ -231,12 +231,12 @@ TEST(EqOp, ElemMatchKeyWithImplicitAndExplicitTraversal) {
     BSONObj operand = BSON("a.0.b" << 3);
     BSONElement operandFirstElt = operand.firstElement();
     EqualityMatchExpression eq(operandFirstElt.fieldName(), operandFirstElt);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     BSONObj obj = fromjson("{a: [{b: [2, 3]}, {b: [4, 5]}]}");
     ASSERT(eq.matchesBSON(obj, &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(EqOp, Equality1) {
@@ -360,15 +360,15 @@ TEST(LtOp, MatchesMaxKey) {
 TEST(LtOp, ElemMatchKey) {
     BSONObj operand = BSON("$lt" << 5);
     LTMatchExpression lt("a", operand["$lt"]);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!lt.matchesBSON(BSON("a" << 6), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(lt.matchesBSON(BSON("a" << 4), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(lt.matchesBSON(BSON("a" << BSON_ARRAY(6 << 2 << 5)), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(LteOp, MatchesElement) {
@@ -475,15 +475,15 @@ TEST(LteOp, MatchesMaxKey) {
 TEST(LteOp, ElemMatchKey) {
     BSONObj operand = BSON("$lte" << 5);
     LTEMatchExpression lte("a", operand["$lte"]);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!lte.matchesBSON(BSON("a" << 6), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(lte.matchesBSON(BSON("a" << 4), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(lte.matchesBSON(BSON("a" << BSON_ARRAY(6 << 2 << 5)), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 DEATH_TEST(GtOp, InvalidEooOperand, "Invariant failure _rhs") {
@@ -577,15 +577,15 @@ TEST(GtOp, MatchesMaxKey) {
 TEST(GtOp, ElemMatchKey) {
     BSONObj operand = BSON("$gt" << 5);
     GTMatchExpression gt("a", operand["$gt"]);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!gt.matchesBSON(BSON("a" << 4), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(gt.matchesBSON(BSON("a" << 6), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(gt.matchesBSON(BSON("a" << BSON_ARRAY(2 << 6 << 5)), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(GteOp, MatchesElement) {
@@ -692,15 +692,15 @@ TEST(GteOp, MatchesMaxKey) {
 TEST(GteOp, ElemMatchKey) {
     BSONObj operand = BSON("$gte" << 5);
     GTEMatchExpression gte("a", operand["$gte"]);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!gte.matchesBSON(BSON("a" << 4), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(gte.matchesBSON(BSON("a" << 6), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(gte.matchesBSON(BSON("a" << BSON_ARRAY(2 << 6 << 5)), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(RegexMatchExpression, MatchesElementExact) {
@@ -887,21 +887,21 @@ TEST(RegexMatchExpression, MatchesNull) {
 
 TEST(RegexMatchExpression, ElemMatchKey) {
     RegexMatchExpression regex("a", "b", "");
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!regex.matchesBSON(BSON("a"
                                    << "c"),
                               &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(regex.matchesBSON(BSON("a"
                                   << "b"),
                              &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(regex.matchesBSON(BSON("a" << BSON_ARRAY("c"
                                                     << "b")),
                              &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(RegexMatchExpression, Equality1) {
@@ -1032,15 +1032,15 @@ TEST(ModMatchExpression, MatchesNull) {
 
 TEST(ModMatchExpression, ElemMatchKey) {
     ModMatchExpression mod("a", 5, 2);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!mod.matchesBSON(BSON("a" << 4), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(mod.matchesBSON(BSON("a" << 2), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(mod.matchesBSON(BSON("a" << BSON_ARRAY(1 << 2 << 5)), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(ModMatchExpression, Equality1) {
@@ -1087,15 +1087,15 @@ TEST(ExistsMatchExpression, MatchesArray) {
 
 TEST(ExistsMatchExpression, ElemMatchKey) {
     ExistsMatchExpression exists("a.b");
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!exists.matchesBSON(BSON("a" << 1), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(exists.matchesBSON(BSON("a" << BSON("b" << 6)), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(exists.matchesBSON(BSON("a" << BSON_ARRAY(2 << BSON("b" << 7))), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(ExistsMatchExpression, Equivalent) {
@@ -1227,15 +1227,15 @@ TEST(InMatchExpression, ElemMatchKey) {
     std::vector<BSONElement> equalities{operand[0], operand[1]};
     ASSERT_OK(in.setEqualities(std::move(equalities)));
 
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!in.matchesBSON(BSON("a" << 4), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(in.matchesBSON(BSON("a" << 5), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(in.matchesBSON(BSON("a" << BSON_ARRAY(1 << 2 << 5)), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(InMatchExpression, InMatchExpressionsWithDifferentNumbersOfElementsAreUnequal) {
diff --git a/src/mongo/db/matcher/expression_path.h b/src/mongo/db/matcher/expression_path.h
index 89cf953fd3..c05f1e04b7 100644
--- a/src/mongo/db/matcher/expression_path.h
+++ b/src/mongo/db/matcher/expression_path.h
@@ -53,15 +53,17 @@ public:
 
     virtual ~PathMatchExpression() {}
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const final {
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* explain = nullptr) const final {
         MatchableDocument::IteratorHolder cursor(doc, &_elementPath);
         while (cursor->more()) {
             ElementIterator::Context e = cursor->next();
-            if (!matchesSingleElement(e.element(), details)) {
+            if (!matchesSingleElement(e.element(), details, explain)) {
                 continue;
             }
-            if (details && details->needRecord() && !e.arrayOffset().eoo()) {
-                details->setElemMatchKey(e.arrayOffset().fieldName());
+            if (details && details->arrayPositionRequested() && !e.arrayOffset().eoo()) {
+                details->setArrayPosition(e.arrayOffset().fieldNameStringData());
             }
             return true;
         }
diff --git a/src/mongo/db/matcher/expression_text.h b/src/mongo/db/matcher/expression_text.h
index 1bf453906b..6e172f3730 100644
--- a/src/mongo/db/matcher/expression_text.h
+++ b/src/mongo/db/matcher/expression_text.h
@@ -48,7 +48,9 @@ public:
         return _ftsQuery;
     }
 
-    bool matchesSingleElement(const BSONElement& e, MatchDetails* details = nullptr) const final {
+    bool matchesSingleElement(const BSONElement& e,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         // Text match expressions force the selection of the text index and always generate EXACT
         // index bounds (which causes the MatchExpression node to be trimmed), so we don't currently
         // implement any explicit text matching logic here. SERVER-17648 tracks the work to
diff --git a/src/mongo/db/matcher/expression_text_noop.h b/src/mongo/db/matcher/expression_text_noop.h
index 3c2316595a..49abe6a7be 100644
--- a/src/mongo/db/matcher/expression_text_noop.h
+++ b/src/mongo/db/matcher/expression_text_noop.h
@@ -41,7 +41,9 @@ public:
         return _ftsQuery;
     }
 
-    bool matchesSingleElement(const BSONElement& e, MatchDetails* details = nullptr) const final {
+    bool matchesSingleElement(const BSONElement& e,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         MONGO_UNREACHABLE;
     }
 
